/* UQLX */
/* fancy code to implement bigger screen */
/* not yet working ... */


#ifdef XSCREEN

#include <stdio.h> 

#include "QLtypes.h"
#include "QL68000.h"
#include "QL.h"
#include "xcodes.h"

#include "driver.h"
#include "Qerror.h"

#include "QInstAddr.h"
#include "unix.h"
#include "uqlx_cfg.h"

#if 0
#define XS_STOREOPEN(_a_,_v_)   (WL(DRV_EPRIV(_a_)+0,(_v_)))
#define XS_GETOPEN(_a_)         (RL(DRV_EPRIV(_a_)+0))
#define XS_STOREIO(_a_,_v_)     (WL(DRV_EPRIV(_a_)+4,(_v_)))
#define XS_GETIO(_a_)           (RL(DRV_EPRIV(_a_)+4))
#define XS_STORECLOSE(_a_,_v_)  (WL(DRV_EPRIV(_a_)+8,(_v_)))
#define XS_GETCLOSE(_a_)        (RL(DRV_EPRIV(_a_)+8))
#define XS_STOREDD(_a_,_v_)     (WL(DRV_EPRIV(_a_)+12,(_v_)))
#endif

static uw32 dr1=0;
static uw32 dr2=0;

/* oadr is QL format, nadr c-pointer ! */
void scan_chans_replace_driver(w32 oadr, char *nadr)
{
  w32 ca;
  w32 ce,cc;
  w32 qnadr=(char*)nadr-(char*)theROM;
  
  ce=ReadLong(0x2807c); /* table top */
  ca=ReadLong(0x28078);

  for(;ca<=ce;ca+=4)
    {
      cc=ReadLong(ca);
      if (ReadLong(cc+4) == oadr)
	WriteLong(cc+4,qnadr);
    }
}


void sdriver_unlink(w32 da)
{
  w32 drp,lp;
  
  lp=0x28044;
  for(drp=ReadLong(lp);drp;lp=drp,drp=ReadLong(drp))
    if (drp==da) break;
  
  if (drp)
    WriteLong(lp,ReadLong(drp));
}


/* fool ptr_gen */
static xic=0;
static uw32 cdrv=0;
static uw32 fpdr;
static uw32 orig_open,orig_io,orig_close,orig_cdrv;

int foolpe=0;


void XfixCh()
{
  uw32 addr;
  
#if 0
  if (reg[0]!=0)
    return;
  
  addr=ReadLong(0x28078);
  addr=ReadLong(addr+4*((uw16)aReg[0]));
  WriteLong(addr+4,fpdr);

  sdriver_unlink(fpdr);
#endif
}

void devpefio_cmd()
{ 
  if((long)((Ptr)gPC-(Ptr)theROM)-2 == DEVPEF_IO_ADDR);
  {
    /*	WriteLong(aReg[0]+4,fpdr);*/
    /*  aReg[3]=fpdr-0x18; */

    /* call modified IO here */
    code=DEVPEFIO_OCODE;
    table[code]();
    
  }
}




int init_con(char * ddef)
{
  uw32 ca;

  if (dr1)
    dr2=ddef-(long)theROM;
  else dr1=ddef-(long)theROM;
  
  
  if (!xic)
    {
      /* get ch#0 */
      ca=ReadLong(0x28078);
      ca=ReadLong(ca);
      /* driver addr */
      ca=ReadLong(ca+4);
      cdrv=ca;
    }
  
  orig_io=ReadLong(cdrv+4);
  orig_open=ReadLong(cdrv+8);
  orig_close=ReadLong(cdrv+12);
  orig_cdrv=cdrv;
  
  printf("original console driver: %x\n",cdrv);

  if (!xic)
#if 1
    scan_chans_replace_driver(cdrv,ddef);
#else
    /**/;
#endif
  
  xic++;
  
  return 0;
}

/* problems that could not be handled by device init */
int init_xscreen()
{
  uw32 ca;

  /* find newly defd scr/con driver */
  /* get ch#0 */
  ca=ReadLong(0x28078);
  ca=ReadLong(ca);
  /* driver addr */
  ca=ReadLong(ca+4);

  /* replace its io routine by patched original ROMs io */
  
  WriteLong(ca+4,orig_io);

  
  DEVPEFIO_OCODE=ReadWord(orig_io);
  WW((Ptr)theROM+orig_io,DEVPEF_CMD_CODE);
  
  table[DEVPEF_CMD_CODE]=devpefio_cmd;
  
}



int scr_init(int id,void *def)
{
  char *p=def;
  int res;
  w32 savedRegs[14*4];
  
  /* useless and dangerous without Minerva */
  if (!isMinerva)
    return -1;
  

  BlockMoveData(reg,savedRegs,14*sizeof(w32));

  /* find QDOS con/scr driver, store addr and unlink it */
  /* set new handler with wdef for PE, bit in $34(a6) */

  printf("call scr_init, id %id, driver defblock %d\n",id,def);

  res=init_con(def);

  if (res<0)
    goto sci_exit;
  
  fpdr=(uw32)((Ptr)def-(Ptr)theROM);
  /* set up screen info block for Pointer Environment */
  /* set new handler with wdef for PE, bit in $34(a6) */

#if 1
  p=p+0x5c-0x18;
  printf("screen definition block at %x\n",(Ptr)p-(Ptr)theROM);
  if(qlscreen.qm_len>0x8000)
    WL(p,RTOP);
  else
    WL(p,qlscreen.qm_lo);

  WL(p+4,qlscreen.qm_len);
  WW(p+8,qlscreen.linel);
  WW(p+10,qlscreen.xres);
  WW(p+12,qlscreen.yres);
  WriteByte(0x28034,1&ReadByte(0x28034));
#endif

 sci_exit:
  BlockMoveData(savedRegs,reg,14*sizeof(w32));
  return res;
}




open_arg scr_par[6];
open_arg scr_par[6];

int scr_test(int id, char *name)
{
  int res;

  /*printf("called scr_test %s\n",name+2);*/
  
  res=decode_name(name,Drivers[id].namep,&scr_par);
  if (res<=0) return res;
  
  if (scr_par[4].i!=-1)  /* has it trailing '_buf' ?*/
    return -1;

  return res;
}

int con_test(int id, char *name)
{
  /*printf("called con_test %s\n",name+2);*/

  return decode_name(name,Drivers[id].namep,&scr_par);
}


int scr_open(int idx, void **priv)
{
  /* call orig driver with params fitting 512x256 */
  /* set real size */
  /* set scrbase,sd_linel etc*/
  printf("opening  %d x %d a %d x %d _%d\n",scr_par[0].i,scr_par[1].i,scr_par[2].i,scr_par[3].i,scr_par[4].i);
#if 0
  (*sp)-=4;
  WriteLong(*sp,XS_GETOPEN((Ptr)theROM+(aReg[3]+0x18)));
#else
  /* set new name */
  QLsubr(orig_open/*XS_GETOPEN((Ptr)theROM+(aReg[3]+0x18))*/,200000000);
#endif

  return 1;  /* special device */
}

void scr_close(int idx, void *priv)
{
  /* pass control to original handler */
    /* fool DRvIO - calling un-rts */
#if 1
  (*sp)-=4;
  aReg[3]=orig_cdrv;
  WriteLong(*sp,orig_close);
#else
  QLsubr(orig_close,20000000);
#endif
}

void scr_io(int idx, void *priv)
{
  /* functionality moved to devpefio_cmd*/
  /*printf("calling scr io ??"); */
#if 1
  /* redefine WINDOW, else */
  /* pass control to original handler */
    /* fool DRvIO - calling un-rts */
  (*sp)-=4;
  aReg[3]=orig_cdrv;
  WriteLong(aReg[0]+4,orig_cdrv);
  WriteLong(*sp,orig_io);
#endif
}

#endif /* XSCREEN */
